apiVersion: elasticsearch.k8s.elastic.co/v1
kind: Elasticsearch
metadata:
  name: elasticsearch
spec:
  version: 7.16.2
  image: gcr.io/project-id/elasticsearch:7.16.2  # repace "project-id" with your project id
  http:
    tls:
      selfSignedCertificate:
        disabled: true
    service:
      spec:
        type: NodePort
        ports:
        - name: elastic-node
          protocol: TCP
          port: 9200
          targetPort: 9200
  secureSettings:
  - secretName: gcs-credentials
  nodeSets:
  - name: master-data
    count: 1
    config:
      node.master: true
      node.data: true
      node.ingest: true
      node.ml: false
      xpack.security.authc:
        anonymous:
          username: anonymous_user 
          roles: monitoring_user
      #reindex.remote.whitelist: [elastic.data.com:443]
    podTemplate:
      spec:
        initContainers:
        - name: sysctl
          securityContext:
            privileged: true
          command: ['sh', '-c', 'sysctl -w vm.max_map_count=262144']
        containers:
        - name: elasticsearch
          env:
          - name: ES_JAVA_OPTS
            value: -Xms3g -Xmx3g
          resources:
            requests:
              memory: 4Gi
              cpu: 1
            limits:
              memory: 4Gi
              cpu: 1
          readinessProbe:
            httpGet:
              scheme: HTTP
              path: /
              port: 9200
        nodeSelector:
          type: elasticsearch
        
    volumeClaimTemplates:
    - metadata:
        name: elasticsearch-data
      spec:
        accessModes:
        - ReadWriteOnce
        resources:
          requests:
            storage: 10Gi
        storageClassName: premium-rwo